import { Component, Injector, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { AppConsts } from '@shared/AppConsts';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { AppComponentBase } from '@shared/common/app-component-base';
import { ControllerDriverListDto, ControllerDriverListServiceProxy } from '@shared/service-proxies/service-proxies';

import * as moment from 'moment';
import { LazyLoadEvent } from 'primeng/components/common/lazyloadevent';
import { Paginator } from 'primeng/components/paginator/paginator';
import { Table } from 'primeng/components/table/table';
import { HttpClient } from '@angular/common/http';
import { finalize } from 'rxjs/operators';

@Component({
	selector: 'driver-tab',
    templateUrl: './driver-list.component.html',
    encapsulation: ViewEncapsulation.None,
   // styleUrls: ['./kpi-box.component.less'],
    animations: [appModuleAnimation()],
    providers: [ControllerDriverListServiceProxy]
})

export class DriverListTabComponent extends AppComponentBase {


	constructor(
        injector: Injector,
        private _controllerDriverListAppService: ControllerDriverListServiceProxy
        
    ) {
        super(injector);
    }

    ngOnInit(): void {

    }

    
}