import { AppComponentBase } from '@shared/common/app-component-base';
import { Component, Input, Injector, ViewEncapsulation, Self, Optional, Output, EventEmitter } from '@angular/core';
import * as moment from 'moment';
import { ControllerVehicleLocationServiceProxy, GetVehicleLocationResultDto } from '@shared/service-proxies/service-proxies';
import { split } from 'lodash';
import { DecimalPipe } from '@angular/common';
import { MapComponent } from '@app/shared/layout/map/map.component';
// import {} from 'googlemaps';

@Component({
  selector: 'locator-tab',
  templateUrl: 'locator.component.html',
  encapsulation: ViewEncapsulation.None,
  providers: [ControllerVehicleLocationServiceProxy]
})
export class LocatorTabComponent extends AppComponentBase{
  
  @Input() filters: {
    locationFilter: number;
    statusFilter: number;
    typeFilter: number;
    startDate: moment.Moment;
    endDate: moment.Moment;
  } = <any>{};

  @Output() locatorTab = new EventEmitter<string>();
  
  data: Array<any> = [{}];

  routes: {
    routeID: number;
    points: any;
  } = <any>{};

  points: {
    orderId: number;
    lat: number;
    long: number;
  } = <any>{};
  results: GetVehicleLocationResultDto = new GetVehicleLocationResultDto

  constructor(
      injector: Injector,
      private _controllerVehicleLocationAppService: ControllerVehicleLocationServiceProxy
  ) {
      super(injector);  
  }

  ngOnInit(): void {
    
  }

}

