import { Component, Injector, OnInit, ViewChild, ViewEncapsulation, Input } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { AppConsts } from '@shared/AppConsts';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { AppComponentBase } from '@shared/common/app-component-base';
import { RouteListDto, RouteServiceProxy } from '@shared/service-proxies/service-proxies';

import * as moment from 'moment';
import { LazyLoadEvent } from 'primeng/components/common/lazyloadevent';
import { Paginator } from 'primeng/components/paginator/paginator';
import { Table } from 'primeng/components/table/table';
import { HttpClient } from '@angular/common/http';
import { finalize } from 'rxjs/operators';
import * as status_icon from './status_icon.json';

@Component({
	selector: 'status',
    templateUrl: './status.component.html',
    encapsulation: ViewEncapsulation.None,
    styleUrls: ['./status.component.less'],
    animations: [appModuleAnimation()]
})

export class StatusComponent extends AppComponentBase implements OnInit {
    hide : boolean;

    @Input('status_code') status_code: string;
    status_value: any;
	constructor(
        injector: Injector,
        private _routeService: RouteServiceProxy
        
    ) {
        super(injector);
    }

    ngOnInit(): void {
       this.status_value = status_icon.default[this.status_code];
    }

    
}